/* Device.c generated by valac 0.46.6, the Vala compiler
 * generated from Device.vala, do not modify */

/*-
 * Copyright (c) 2017-2017 Artem Anufrij <artem.anufrij@live.de>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Artem Anufrij <artem.anufrij@live.de>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define IMAGEBURNER_TYPE_DEVICE (imageburner_device_get_type ())
#define IMAGEBURNER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IMAGEBURNER_TYPE_DEVICE, ImageburnerDevice))
#define IMAGEBURNER_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), IMAGEBURNER_TYPE_DEVICE, ImageburnerDeviceClass))
#define IMAGEBURNER_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IMAGEBURNER_TYPE_DEVICE))
#define IMAGEBURNER_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IMAGEBURNER_TYPE_DEVICE))
#define IMAGEBURNER_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), IMAGEBURNER_TYPE_DEVICE, ImageburnerDeviceClass))

typedef struct _ImageburnerDevice ImageburnerDevice;
typedef struct _ImageburnerDeviceClass ImageburnerDeviceClass;
typedef struct _ImageburnerDevicePrivate ImageburnerDevicePrivate;
enum  {
	IMAGEBURNER_DEVICE_0_PROPERTY,
	IMAGEBURNER_DEVICE_DRIVE_PROPERTY,
	IMAGEBURNER_DEVICE_IS_CARD_PROPERTY,
	IMAGEBURNER_DEVICE_NUM_PROPERTIES
};
static GParamSpec* imageburner_device_properties[IMAGEBURNER_DEVICE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ImageburnerDevice {
	GtkFlowBoxChild parent_instance;
	ImageburnerDevicePrivate * priv;
};

struct _ImageburnerDeviceClass {
	GtkFlowBoxChildClass parent_class;
};

struct _ImageburnerDevicePrivate {
	GtkGrid* content;
	GtkImage* icon;
	GtkLabel* title;
	GDrive* _drive;
};

static gint ImageburnerDevice_private_offset;
static gpointer imageburner_device_parent_class = NULL;

GType imageburner_device_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ImageburnerDevice, g_object_unref)
ImageburnerDevice* imageburner_device_new (GDrive* d);
ImageburnerDevice* imageburner_device_construct (GType object_type,
                                                 GDrive* d);
static void imageburner_device_set_drive (ImageburnerDevice* self,
                                   GDrive* value);
GtkImage* imageburner_device_get_medium_icon (ImageburnerDevice* self);
gchar* imageburner_device_get_unix_device (ImageburnerDevice* self);
GDrive* imageburner_device_get_drive (ImageburnerDevice* self);
gboolean imageburner_device_get_is_card (ImageburnerDevice* self);
GtkImage* imageburner_device_get_large_icon (ImageburnerDevice* self);
void imageburner_device_umount_all_volumes (ImageburnerDevice* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static GObject * imageburner_device_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void imageburner_device_finalize (GObject * obj);
static void _vala_imageburner_device_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_imageburner_device_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
imageburner_device_get_instance_private (ImageburnerDevice* self)
{
	return G_STRUCT_MEMBER_P (self, ImageburnerDevice_private_offset);
}

ImageburnerDevice*
imageburner_device_construct (GType object_type,
                              GDrive* d)
{
	ImageburnerDevice * self = NULL;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkGrid* _tmp6_;
	GtkImage* _tmp7_;
	GtkGrid* _tmp8_;
	GtkLabel* _tmp9_;
#line 44 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	g_return_val_if_fail (d != NULL, NULL);
#line 44 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	self = (ImageburnerDevice*) g_object_new (object_type, NULL);
#line 45 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	imageburner_device_set_drive (self, d);
#line 47 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp0_ = imageburner_device_get_medium_icon (self);
#line 47 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->icon);
#line 47 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	self->priv->icon = _tmp0_;
#line 48 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp1_ = self->priv->icon;
#line 48 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	g_object_set ((GtkWidget*) _tmp1_, "margin", 6, NULL);
#line 49 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp2_ = g_drive_get_name (d);
#line 49 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp3_ = _tmp2_;
#line 49 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new (_tmp3_);
#line 49 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	g_object_ref_sink (_tmp4_);
#line 49 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->title);
#line 49 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	self->priv->title = _tmp4_;
#line 49 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_g_free0 (_tmp3_);
#line 50 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp5_ = self->priv->title;
#line 50 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	gtk_widget_set_margin_right ((GtkWidget*) _tmp5_, 6);
#line 51 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp6_ = self->priv->content;
#line 51 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp7_ = self->priv->icon;
#line 51 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	gtk_grid_attach (_tmp6_, (GtkWidget*) _tmp7_, 0, 0, 1, 1);
#line 52 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp8_ = self->priv->content;
#line 52 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp9_ = self->priv->title;
#line 52 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	gtk_grid_attach (_tmp8_, (GtkWidget*) _tmp9_, 1, 0, 1, 1);
#line 44 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	return self;
#line 175 "Device.c"
}

ImageburnerDevice*
imageburner_device_new (GDrive* d)
{
#line 44 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	return imageburner_device_construct (IMAGEBURNER_TYPE_DEVICE, d);
#line 183 "Device.c"
}

gchar*
imageburner_device_get_unix_device (ImageburnerDevice* self)
{
	GDrive* _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 64 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 65 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp0_ = self->priv->_drive;
#line 65 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp1_ = g_drive_get_identifier (_tmp0_, "unix-device");
#line 65 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	result = _tmp1_;
#line 65 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	return result;
#line 202 "Device.c"
}

GtkImage*
imageburner_device_get_medium_icon (ImageburnerDevice* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GDrive* _tmp3_;
	GIcon* _tmp4_;
	GIcon* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* result = NULL;
#line 68 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp0_ = imageburner_device_get_is_card (self);
#line 69 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp1_ = _tmp0_;
#line 69 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	if (_tmp1_) {
#line 224 "Device.c"
		GtkImage* _tmp2_;
#line 70 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name ("media-flash", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 70 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		g_object_ref_sink (_tmp2_);
#line 70 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		result = _tmp2_;
#line 70 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		return result;
#line 234 "Device.c"
	}
#line 72 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp3_ = self->priv->_drive;
#line 72 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp4_ = g_drive_get_icon (_tmp3_);
#line 72 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp5_ = _tmp4_;
#line 72 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp6_ = (GtkImage*) gtk_image_new_from_gicon (_tmp5_, (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 72 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	g_object_ref_sink (_tmp6_);
#line 72 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp7_ = _tmp6_;
#line 72 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_g_object_unref0 (_tmp5_);
#line 72 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	result = _tmp7_;
#line 72 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	return result;
#line 254 "Device.c"
}

GtkImage*
imageburner_device_get_large_icon (ImageburnerDevice* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GDrive* _tmp3_;
	GIcon* _tmp4_;
	GIcon* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* result = NULL;
#line 75 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 76 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp0_ = imageburner_device_get_is_card (self);
#line 76 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp1_ = _tmp0_;
#line 76 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	if (_tmp1_) {
#line 276 "Device.c"
		GtkImage* _tmp2_;
#line 77 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name ("media-flash", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 77 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		g_object_ref_sink (_tmp2_);
#line 77 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		result = _tmp2_;
#line 77 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		return result;
#line 286 "Device.c"
	}
#line 79 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp3_ = self->priv->_drive;
#line 79 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp4_ = g_drive_get_icon (_tmp3_);
#line 79 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp5_ = _tmp4_;
#line 79 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp6_ = (GtkImage*) gtk_image_new_from_gicon (_tmp5_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 79 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	g_object_ref_sink (_tmp6_);
#line 79 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp7_ = _tmp6_;
#line 79 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_g_object_unref0 (_tmp5_);
#line 79 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	result = _tmp7_;
#line 79 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	return result;
#line 306 "Device.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 83 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	return self ? g_object_ref (self) : NULL;
#line 314 "Device.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 83 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 322 "Device.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 83 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 330 "Device.c"
}

void
imageburner_device_umount_all_volumes (ImageburnerDevice* self)
{
	GDrive* _tmp0_;
	GList* _tmp1_;
#line 82 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	g_return_if_fail (self != NULL);
#line 83 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp0_ = self->priv->_drive;
#line 83 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp1_ = g_drive_get_volumes (_tmp0_);
#line 344 "Device.c"
	{
		GList* volume_collection = NULL;
		GList* volume_it = NULL;
#line 83 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		volume_collection = _tmp1_;
#line 83 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		for (volume_it = volume_collection; volume_it != NULL; volume_it = volume_it->next) {
#line 352 "Device.c"
			GVolume* _tmp2_;
			GVolume* volume = NULL;
#line 83 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
			_tmp2_ = _g_object_ref0 ((GVolume*) volume_it->data);
#line 83 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
			volume = _tmp2_;
#line 359 "Device.c"
			{
				GVolume* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				GMount* mount = NULL;
				GVolume* _tmp6_;
				GMount* _tmp7_;
				GMount* _tmp8_;
#line 84 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
				_tmp3_ = volume;
#line 84 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
				_tmp4_ = g_volume_get_name (_tmp3_);
#line 84 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
				_tmp5_ = _tmp4_;
#line 84 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
				g_debug ("Device.vala:84: volume: %s", _tmp5_);
#line 84 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
				_g_free0 (_tmp5_);
#line 85 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
				_tmp6_ = volume;
#line 85 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
				_tmp7_ = g_volume_get_mount (_tmp6_);
#line 85 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
				mount = _tmp7_;
#line 87 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
				_tmp8_ = mount;
#line 87 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
				if (_tmp8_ != NULL) {
#line 388 "Device.c"
					GMount* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					GMount* _tmp12_;
#line 88 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
					_tmp9_ = mount;
#line 88 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
					_tmp10_ = g_mount_get_name (_tmp9_);
#line 88 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
					_tmp11_ = _tmp10_;
#line 88 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
					g_debug ("Device.vala:88: umount %s", _tmp11_);
#line 88 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
					_g_free0 (_tmp11_);
#line 89 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
					_tmp12_ = mount;
#line 89 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
					g_mount_unmount_with_operation (_tmp12_, G_MOUNT_UNMOUNT_FORCE, NULL, NULL, NULL, NULL);
#line 407 "Device.c"
				}
#line 83 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
				_g_object_unref0 (mount);
#line 83 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
				_g_object_unref0 (volume);
#line 413 "Device.c"
			}
		}
#line 83 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		(volume_collection == NULL) ? NULL : (volume_collection = (_g_list_free__g_object_unref0_ (volume_collection), NULL));
#line 418 "Device.c"
	}
}

GDrive*
imageburner_device_get_drive (ImageburnerDevice* self)
{
	GDrive* result;
	GDrive* _tmp0_;
#line 35 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp0_ = self->priv->_drive;
#line 35 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	result = _tmp0_;
#line 35 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	return result;
#line 435 "Device.c"
}

static void
imageburner_device_set_drive (ImageburnerDevice* self,
                              GDrive* value)
{
#line 35 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	g_return_if_fail (self != NULL);
#line 35 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	if (imageburner_device_get_drive (self) != value) {
#line 446 "Device.c"
		GDrive* _tmp0_;
#line 35 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 35 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		_g_object_unref0 (self->priv->_drive);
#line 35 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		self->priv->_drive = _tmp0_;
#line 35 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, imageburner_device_properties[IMAGEBURNER_DEVICE_DRIVE_PROPERTY]);
#line 456 "Device.c"
	}
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result = 0;
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1082 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1082 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1084 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1084 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 481 "Device.c"
		gchar* _tmp2_;
#line 1085 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1085 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1085 "glib-2.0.vapi"
		return result;
#line 489 "Device.c"
	} else {
#line 1087 "glib-2.0.vapi"
		result = -1;
#line 1087 "glib-2.0.vapi"
		return result;
#line 495 "Device.c"
	}
}

gboolean
imageburner_device_get_is_card (ImageburnerDevice* self)
{
	gboolean result;
	gchar* unix_device = NULL;
	GDrive* _tmp0_;
	gchar* _tmp1_;
#line 57 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 58 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp0_ = self->priv->_drive;
#line 58 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp1_ = g_drive_get_identifier (_tmp0_, "unix-device");
#line 58 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	unix_device = _tmp1_;
#line 59 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	result = string_index_of (unix_device, "/dev/mmc", 0) == 0;
#line 59 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_g_free0 (unix_device);
#line 59 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	return result;
#line 520 "Device.c"
}

static GObject *
imageburner_device_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ImageburnerDevice * self;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	GtkGrid* _tmp3_;
#line 37 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	parent_class = G_OBJECT_CLASS (imageburner_device_parent_class);
#line 37 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 37 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, IMAGEBURNER_TYPE_DEVICE, ImageburnerDevice);
#line 38 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
#line 38 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	g_object_ref_sink (_tmp0_);
#line 38 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->content);
#line 38 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	self->priv->content = _tmp0_;
#line 39 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp1_ = self->priv->content;
#line 39 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	gtk_grid_set_row_spacing (_tmp1_, 12);
#line 40 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp2_ = self->priv->content;
#line 40 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
#line 41 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_tmp3_ = self->priv->content;
#line 41 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp3_);
#line 37 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	return obj;
#line 563 "Device.c"
}

static void
imageburner_device_class_init (ImageburnerDeviceClass * klass,
                               gpointer klass_data)
{
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	imageburner_device_parent_class = g_type_class_peek_parent (klass);
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	g_type_class_adjust_private_offset (klass, &ImageburnerDevice_private_offset);
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_imageburner_device_get_property;
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_imageburner_device_set_property;
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	G_OBJECT_CLASS (klass)->constructor = imageburner_device_constructor;
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	G_OBJECT_CLASS (klass)->finalize = imageburner_device_finalize;
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), IMAGEBURNER_DEVICE_DRIVE_PROPERTY, imageburner_device_properties[IMAGEBURNER_DEVICE_DRIVE_PROPERTY] = g_param_spec_object ("drive", "drive", "drive", g_drive_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), IMAGEBURNER_DEVICE_IS_CARD_PROPERTY, imageburner_device_properties[IMAGEBURNER_DEVICE_IS_CARD_PROPERTY] = g_param_spec_boolean ("is-card", "is-card", "is-card", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 586 "Device.c"
}

static void
imageburner_device_instance_init (ImageburnerDevice * self,
                                  gpointer klass)
{
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	self->priv = imageburner_device_get_instance_private (self);
#line 595 "Device.c"
}

static void
imageburner_device_finalize (GObject * obj)
{
	ImageburnerDevice * self;
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, IMAGEBURNER_TYPE_DEVICE, ImageburnerDevice);
#line 31 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->content);
#line 32 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->icon);
#line 33 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->title);
#line 35 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	_g_object_unref0 (self->priv->_drive);
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	G_OBJECT_CLASS (imageburner_device_parent_class)->finalize (obj);
#line 614 "Device.c"
}

GType
imageburner_device_get_type (void)
{
	static volatile gsize imageburner_device_type_id__volatile = 0;
	if (g_once_init_enter (&imageburner_device_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ImageburnerDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) imageburner_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImageburnerDevice), 0, (GInstanceInitFunc) imageburner_device_instance_init, NULL };
		GType imageburner_device_type_id;
		imageburner_device_type_id = g_type_register_static (gtk_flow_box_child_get_type (), "ImageburnerDevice", &g_define_type_info, 0);
		ImageburnerDevice_private_offset = g_type_add_instance_private (imageburner_device_type_id, sizeof (ImageburnerDevicePrivate));
		g_once_init_leave (&imageburner_device_type_id__volatile, imageburner_device_type_id);
	}
	return imageburner_device_type_id__volatile;
}

static void
_vala_imageburner_device_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	ImageburnerDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, IMAGEBURNER_TYPE_DEVICE, ImageburnerDevice);
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	switch (property_id) {
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		case IMAGEBURNER_DEVICE_DRIVE_PROPERTY:
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		g_value_set_object (value, imageburner_device_get_drive (self));
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		break;
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		case IMAGEBURNER_DEVICE_IS_CARD_PROPERTY:
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		g_value_set_boolean (value, imageburner_device_get_is_card (self));
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		break;
#line 653 "Device.c"
		default:
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		break;
#line 659 "Device.c"
	}
}

static void
_vala_imageburner_device_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	ImageburnerDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, IMAGEBURNER_TYPE_DEVICE, ImageburnerDevice);
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
	switch (property_id) {
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		case IMAGEBURNER_DEVICE_DRIVE_PROPERTY:
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		imageburner_device_set_drive (self, g_value_get_object (value));
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		break;
#line 679 "Device.c"
		default:
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "/home/abuild/rpmbuild/BUILD/imageburner-0.1.15/src/Widgets/Device.vala"
		break;
#line 685 "Device.c"
	}
}

